=== modified file 'client/include.am'
--- client/include.am	2010-06-16 02:27:44 +0000
+++ client/include.am	2010-06-17 13:06:04 +0000
@@ -10,10 +10,6 @@
 	      gnulib/libgnu.la \
 	      client/libgetpassword.la
 
-CLIENT_CXXFLAGS= \
-                 ${AM_CXXFLAGS} \
-		 ${BOOSTSKIP_WARNINGS}
-
 noinst_LTLIBRARIES+= \
 		     client/libgetpassword.la
 
@@ -50,22 +46,17 @@
 				$(LIBZ) \
 				gnulib/libgnu.la \
 				client/libgetpassword.la
-client_drizzle_CXXFLAGS=	${CLIENT_CXXFLAGS}
 
 client_drizzledump_SOURCES=	client/drizzledump.cc
 client_drizzledump_LDADD=	${CLIENT_LDADD}
-client_drizzledump_CXXFLAGS=	${CLIENT_CXXFLAGS}
 
 client_drizzleimport_SOURCES=	client/drizzleimport.cc
 client_drizzleimport_LDADD=	${CLIENT_LDADD} ${BOOST_LIBS}
-client_drizzleimport_CXXFLAGS=	${CLIENT_CXXFLAGS}
 
 client_drizzleslap_SOURCES=	client/drizzleslap.cc
 client_drizzleslap_LDADD=	${CLIENT_LDADD} ${BOOST_LIBS}
-client_drizzleslap_CXXFLAGS=	${CLIENT_CXXFLAGS}
 
 client_drizzletest_SOURCES=	client/drizzletest.cc client/errname.cc
 client_drizzletest_LDADD=	${CLIENT_LDADD} ${BOOST_LIBS} ${LIBPCRE} 
-client_drizzletest_CXXFLAGS=	${CLIENT_CXXFLAGS}
  
 

=== modified file 'config/pandora-plugin.ini'
--- config/pandora-plugin.ini	2010-05-12 05:00:02 +0000
+++ config/pandora-plugin.ini	2010-06-16 22:09:44 +0000
@@ -2,6 +2,6 @@
 root_plugin_dir=plugin
 pkgplugindir=$(libdir)/drizzle
 plugin_suffix=_plugin
-extra_cxxflags=-DBUILDING_DRIZZLE
+extra_cxxflags=-DBUILDING_DRIZZLED
 force_lowercase_libname=True
 plugin_ini_fname=plugin.ini

=== modified file 'configure.ac'
--- configure.ac	2010-06-05 21:39:51 +0000
+++ configure.ac	2010-06-16 22:09:44 +0000
@@ -60,7 +60,7 @@
 PANDORA_USE_BETTER_MALLOC
 
 PANDORA_DRIZZLE_BUILD
-AC_DEFINE([BUILDING_DRIZZLE],[1],
+AC_DEFINE([BUILDING_DRIZZLED],[1],
           [Define indicating we are building and not consuming drizzle.])
 
 PANDORA_HAVE_LIBGTEST

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-06-12 18:21:15 +0000
+++ drizzled/include.am	2010-06-16 22:09:59 +0000
@@ -257,6 +257,7 @@
 			      drizzled/module/library.h \
 			      drizzled/module/manifest.h \
 			      drizzled/module/module.h \
+			      drizzled/module/option_context.h \
 			      drizzled/module/registry.h \
 			      drizzled/my_hash.h \
 			      drizzled/name_resolution_context.h \
@@ -458,6 +459,7 @@
 				$(LIBPCRE) \
 				$(LTLIBPROTOBUF) \
 				$(LIBTBB) \
+				$(BOOST_LIBS) \
 				$(GCOV_LIBS) 
 
 drizzled_drizzled_DEPENDENCIES= \
@@ -645,6 +647,7 @@
 				 drizzled/lookup_symbol.cc \
 				 drizzled/module/library.cc \
 				 drizzled/module/loader.cc \
+				 drizzled/module/option_context.cc \
 				 drizzled/module/registry.cc \
 				 drizzled/my_getsystime.cc \
 				 drizzled/my_hash.cc \

=== modified file 'drizzled/module/loader.cc'
--- drizzled/module/loader.cc	2010-05-18 18:20:56 +0000
+++ drizzled/module/loader.cc	2010-06-18 19:20:32 +0000
@@ -22,6 +22,9 @@
 #include <vector>
 #include <map>
 #include <algorithm>
+#include <iostream>
+
+#include <boost/program_options.hpp>
 
 #include "drizzled/option.h"
 #include "drizzled/my_hash.h"
@@ -31,6 +34,7 @@
 #include "drizzled/module/load_list.h"
 #include "drizzled/module/library.h"
 #include "drizzled/module/registry.h"
+#include "drizzled/module/option_context.h"
 #include "drizzled/sql_parse.h"
 #include "drizzled/show.h"
 #include "drizzled/cursor.h"
@@ -49,6 +53,8 @@
 #define RTLD_NOW 1
 #endif
 
+namespace po=boost::program_options;
+
 using namespace std;
 
 /** These exist just to prevent symbols from being optimized out */
@@ -1653,7 +1659,8 @@
   NOTE:
     Requires that a write-lock is held on LOCK_system_variables_hash
 */
-static int test_plugin_options(memory::Root *tmp_root, module::Module *tmp,
+static int test_plugin_options(memory::Root *module_root,
+                               module::Module *test_module,
                                int *argc, char **argv)
 {
   struct sys_var_chain chain= { NULL, NULL };
@@ -1664,22 +1671,65 @@
   struct st_bookmark *var;
   uint32_t len, count= EXTRA_OPTIONS;
 
-  for (opt= tmp->getManifest().system_vars; opt && *opt; opt++)
+  if (test_module->getManifest().init_options != NULL)
+  {
+    cout << "Calling init_options: " << test_module->getName() << endl;
+    po::options_description module_options("Options used by plugins");
+    module::option_context opt_ctx(test_module->getName(),
+                                   module_options.add_options());
+    test_module->getManifest().init_options(opt_ctx);
+
+    po::variables_map vm;
+
+    po::parsed_options parsed= po::command_line_parser(*argc, argv).
+      options(module_options).allow_unregistered().run();
+
+    po::store(parsed, vm);
+
+    vector<string> to_pass_further= po::collect_unrecognized(parsed.options,
+                                                             po::include_positional);
+
+
+    /* Copy the left over options back into argv for further processing.
+       Once the core is using program options, this whole thing will be done
+       differently.
+     */
+    for (vector<string>::iterator iter= to_pass_further.begin();
+         iter != to_pass_further.end();
+         ++iter)
+    {
+      size_t pos= iter-to_pass_further.begin()+1;
+      memcpy(argv[pos], (*iter).c_str(), (*iter).size()+1);
+      cout << "arg: *" << argv[pos] << "*" << endl;
+    }
+    *argc= to_pass_further.size() + 1;
+
+    po::notify(vm);
+  }
+  else
+  {
+
+  for (opt= test_module->getManifest().system_vars; opt && *opt; opt++)
+  {
     count++;
-
+  }
 
   if (count > EXTRA_OPTIONS || (*argc > 1))
   {
-    if (!(opts= (option*) tmp_root->alloc_root(sizeof(option) * count)))
+    if (!(opts= (option*) module_root->alloc_root(sizeof(option) * count)))
     {
-      errmsg_printf(ERRMSG_LVL_ERROR, _("Out of memory for plugin '%s'."), tmp->getName().c_str());
+      errmsg_printf(ERRMSG_LVL_ERROR,
+                    _("Out of memory for plugin '%s'."),
+                    test_module->getName().c_str());
       return(-1);
     }
     memset(opts, 0, sizeof(option) * count);
 
-    if (construct_options(tmp_root, tmp, opts))
+    if (construct_options(module_root, test_module, opts))
     {
-      errmsg_printf(ERRMSG_LVL_ERROR, _("Bad options for plugin '%s'."), tmp->getName().c_str());
+      errmsg_printf(ERRMSG_LVL_ERROR,
+                    _("Bad options for plugin '%s'."),
+                    test_module->getName().c_str());
       return(-1);
     }
 
@@ -1688,27 +1738,31 @@
 
     if (error)
     {
-       errmsg_printf(ERRMSG_LVL_ERROR, _("Parsing options for plugin '%s' failed."),
-                       tmp->getName().c_str());
-       goto err;
+      errmsg_printf(ERRMSG_LVL_ERROR,
+                    _("Parsing options for plugin '%s' failed."),
+                    test_module->getName().c_str());
+      goto err;
     }
   }
+  }
 
   error= 1;
 
   {
-    for (opt= tmp->getManifest().system_vars; opt && *opt; opt++)
+    for (opt= test_module->getManifest().system_vars; opt && *opt; opt++)
     {
       sys_var *v;
       if (((o= *opt)->flags & PLUGIN_VAR_NOSYSVAR))
         continue;
 
-      if ((var= find_bookmark(tmp->getName(), o->name, o->flags)))
+      if ((var= find_bookmark(test_module->getName(), o->name, o->flags)))
+      {
         v= new sys_var_pluginvar(var->key + 1, o);
+      }
       else
       {
-        len= tmp->getName().length() + strlen(o->name) + 2;
-        string vname(tmp->getName());
+        len= test_module->getName().length() + strlen(o->name) + 2;
+        string vname(test_module->getName());
         vname.push_back('-');
         vname.append(o->name);
         transform(vname.begin(), vname.end(), vname.begin(), ::tolower);
@@ -1737,11 +1791,12 @@
       chain.last->setNext(NULL);
       if (mysql_add_sys_var_chain(chain.first, NULL))
       {
-        errmsg_printf(ERRMSG_LVL_ERROR, _("Plugin '%s' has conflicting system variables"),
-                        tmp->getName().c_str());
+        errmsg_printf(ERRMSG_LVL_ERROR,
+                      _("Plugin '%s' has conflicting system variables"),
+                      test_module->getName().c_str());
         goto err;
       }
-      tmp->system_vars= chain.first;
+      test_module->system_vars= chain.first;
     }
     return(0);
   }

=== modified file 'drizzled/module/manifest.h'
--- drizzled/module/manifest.h	2010-05-18 18:20:56 +0000
+++ drizzled/module/manifest.h	2010-06-18 00:34:51 +0000
@@ -27,6 +27,7 @@
  */
 
 #include "drizzled/module/context.h"
+#include "drizzled/module/option_context.h"
 
 namespace drizzled
 {
@@ -48,6 +49,7 @@
 {
 
 typedef int (*initialize_func_t)(::drizzled::module::Context &);
+typedef void (*options_func_t)(::drizzled::module::option_context &);
 
 /**
  * Plugin Manfiest
@@ -67,7 +69,7 @@
   plugin_license_type license; /* plugin license (PLUGIN_LICENSE_XXX)          */
   initialize_func_t init;     /* function to invoke when plugin is loaded     */
   drizzle_sys_var **system_vars;
-  void *reserved1;           /* reserved for dependency checking             */
+  options_func_t init_options; /* register command line options              */
 };
 
 } /* namespace module */

=== added file 'drizzled/module/option_context.cc'
--- drizzled/module/option_context.cc	1970-01-01 00:00:00 +0000
+++ drizzled/module/option_context.cc	2010-06-16 22:09:59 +0000
@@ -0,0 +1,66 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Monty Taylor
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include "option_context.h"
+
+namespace drizzled
+{
+namespace module
+{
+
+
+option_context::option_context(const std::string &module_name_in,
+                               po::options_description_easy_init po_options_in) :
+  module_name(module_name_in),
+  po_options(po_options_in)
+{ }
+
+option_context& option_context::operator()(const char* name,
+                                           const char* description)
+{
+  const std::string new_name(prepend_name(name));
+  po_options(new_name.c_str(), description);
+  return *this;
+}
+
+
+option_context& option_context::operator()(const char* name,
+                                           const po::value_semantic* s)
+{
+  const std::string new_name(prepend_name(name));
+  po_options(new_name.c_str(), s);
+  return *this;
+}
+
+
+option_context& option_context::operator()(const char* name,
+                             const po::value_semantic* s,
+                             const char* description)
+{
+  const std::string new_name(prepend_name(name));
+  po_options(new_name.c_str(), s, description);
+  return *this;
+}
+
+
+} /* namespace module */
+} /* namespace drizzled */
+

=== added file 'drizzled/module/option_context.h'
--- drizzled/module/option_context.h	1970-01-01 00:00:00 +0000
+++ drizzled/module/option_context.h	2010-06-16 22:09:59 +0000
@@ -0,0 +1,100 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Monty Taylor
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+/**
+ * @file
+ * @brief An Proxy Wrapper around options_description_easy_init
+ */
+
+#ifndef DRIZZLED_MODULE_OPTION_CONTEXT_H
+#define DRIZZLED_MODULE_OPTION_CONTEXT_H
+
+#include "drizzled/visibility.h"
+
+#include <boost/program_options.hpp>
+
+#include <string>
+
+namespace drizzled
+{
+namespace module
+{
+
+namespace po=boost::program_options;
+
+/**
+ * Options proxy wrapper. Provides pre-pending of module name to each option
+ * which is added.
+ */
+class DRIZZLED_API option_context
+{
+  const std::string &module_name;
+  po::options_description_easy_init po_options;
+
+  std::string prepend_name(const char *name) const;
+
+public:
+
+  option_context(const std::string &module_name_in,
+                 po::options_description_easy_init po_options_in);
+
+  option_context& operator()(const char* name,
+                             const char* description);
+
+  option_context& operator()(const char* name,
+                             const po::value_semantic* s);
+
+  option_context& operator()(const char* name,
+                             const po::value_semantic* s,
+                             const char* description);
+
+private:
+  
+  /**
+   * Don't allow default construction.
+   */
+  option_context();
+
+  /**
+   * Don't allow copying of objects.
+   */
+  option_context(const option_context &);
+
+  /**
+   * Don't allow assignment of objects.
+   */
+  option_context& operator=(const option_context &);
+};
+
+/*
+ * Private methods.
+ */
+inline std::string option_context::prepend_name(const char *name_in) const
+{
+  std::string new_name(module_name);
+  new_name.push_back('.');
+  new_name.append(name_in);
+  return new_name;
+}
+
+} /* namespace module */
+} /* namespace drizzled */
+
+
+#endif /* DRIZZLED_MODULE_OPTION_CONTEXT_H */

=== modified file 'drizzled/plugin/listen_tcp.cc'
--- drizzled/plugin/listen_tcp.cc	2010-04-23 01:02:40 +0000
+++ drizzled/plugin/listen_tcp.cc	2010-06-18 19:20:00 +0000
@@ -193,24 +193,24 @@
         break;
       }
 
-      errmsg_printf(ERRMSG_LVL_INFO, _("Retrying bind() on %u"), getPort());
+      errmsg_printf(ERRMSG_LVL_INFO, _("Retrying bind() on %u\n"), getPort());
       this_wait= retry * retry / 3 + 1;
       sleep(this_wait);
     }
 
     if (ret < 0)
     {
-      errmsg_printf(ERRMSG_LVL_ERROR, _("bind() failed with errno: %d"),
+      errmsg_printf(ERRMSG_LVL_ERROR, _("bind() failed with errno: %d\n"),
                     errno);
       errmsg_printf(ERRMSG_LVL_ERROR,
-                    _("Do you already have another drizzled running?"));
+                    _("Do you already have another drizzled running?\n"));
       return true;
     }
 
     if (listen(fd, (int) back_log) < 0)
     {
       errmsg_printf(ERRMSG_LVL_ERROR,
-                    _("listen() failed with errno %d"), errno);
+                    _("listen() failed with errno %d\n"), errno);
       return true;
     }
 

=== modified file 'drizzled/visibility.h'
--- drizzled/visibility.h	2010-03-02 18:26:26 +0000
+++ drizzled/visibility.h	2010-06-16 22:09:44 +0000
@@ -29,31 +29,43 @@
 
 /**
  *
- * DRIZZLE_API is used for the public API symbols. It either DLL imports or
+ * DRIZZLED_API is used for the public API symbols. It either DLL imports or
  * DLL exports (or does nothing for static build).
  *
- * DRIZZLE_LOCAL is used for non-api symbols.
+ * DRIZZLED_LOCAL is used for non-api symbols.
  */
 
-#if defined(BUILDING_DRIZZLE)
-# if defined(HAVE_VISIBILITY)
-#  define DRIZZLE_API __attribute__ ((visibility("default")))
-#  define DRIZZLE_LOCAL  __attribute__ ((visibility("hidden")))
-# elif defined (__SUNPRO_C) && (__SUNPRO_C >= 0x550)
-#  define DRIZZLE_API __global
-#  define DRIZZLE_API __hidden
+#if defined(BUILDING_DRIZZLED) && defined(HAVE_VISIBILITY)
+# if defined(__GNUC__)
+#  define DRIZZLED_API __attribute__ ((visibility("default")))
+#  define DRIZZLED_INTERNAL_API __attribute__ ((visibility("hidden")))
+#  define DRIZZLED_API_DEPRECATED __attribute__ ((deprecated,visibility("default")))
+#  define DRIZZLED_LOCAL  __attribute__ ((visibility("hidden")))
+# elif (defined(__SUNPRO_C) && (__SUNPRO_C >= 0x550)) || (defined(__SUNPRO_CC) && (__SUNPRO_CC >= 0x550))
+#  define DRIZZLED_API __global
+#  define DRIZZLED_INTERNAL_API __hidden
+#  define DRIZZLED_API_DEPRECATED __global
+#  define DRIZZLED_LOCAL __hidden
 # elif defined(_MSC_VER)
-#  define DRIZZLE_API extern __declspec(dllexport) 
-#  define DRIZZLE_LOCAL
-# endif /* defined(HAVE_VISIBILITY) */
-#else  /* defined(BUILDING_DRIZZLE) */
+#  define DRIZZLED_API extern __declspec(dllexport)
+#  define DRIZZLED_INTERNAL_API extern __declspec(dllexport)
+#  define DRIZZLED_DEPRECATED_API extern __declspec(dllexport)
+#  define DRIZZLED_LOCAL
+# endif
+#else  /* defined(BUILDING_DRIZZLED) && defined(HAVE_VISIBILITY) */
 # if defined(_MSC_VER)
-#  define DRIZZLE_API extern __declspec(dllimport) 
-#  define DRIZZLE_LOCAL
+#  define DRIZZLED_API extern __declspec(dllimport)
+#  define DRIZZLED_INTERNAL_API extern __declspec(dllimport)
+#  define DRIZZLED_API_DEPRECATED extern __declspec(dllimport)
+#  define DRIZZLED_LOCAL
 # else
-#  define DRIZZLE_API
-#  define DRIZZLE_LOCAL
+#  define DRIZZLED_API
+#  define DRIZZLED_INTERNAL_API
+#  define DRIZZLED_API_DEPRECATED
+#  define DRIZZLED_LOCAL
 # endif /* defined(_MSC_VER) */
-#endif /* defined(BUILDING_DRIZZLE) */
+#endif  /* defined(BUILDING_DRIZZLED) && defined(HAVE_VISIBILITY) */
+
+
 
 #endif /* DRIZZLED_VISIBILITY_H */

=== modified file 'plugin/console/console.cc'
--- plugin/console/console.cc	2010-05-18 18:20:56 +0000
+++ plugin/console/console.cc	2010-06-18 19:26:52 +0000
@@ -21,9 +21,13 @@
 
 #include <iostream>
 
+#include <boost/program_options.hpp>
+
 using namespace std;
 using namespace drizzled;
 
+namespace po= boost::program_options;
+
 static bool enabled= false;
 static bool debug_enabled= false;
 static char* user = (char*)"";
@@ -319,9 +323,9 @@
 
 static DRIZZLE_SYSVAR_BOOL(enable, enabled, PLUGIN_VAR_NOCMDARG,
                            N_("Enable the console."), NULL, NULL, false);
-
 static DRIZZLE_SYSVAR_BOOL(debug, debug_enabled, PLUGIN_VAR_NOCMDARG,
                            N_("Turn on extra debugging."), NULL, NULL, false);
+
 static DRIZZLE_SYSVAR_STR(user, user, PLUGIN_VAR_READONLY,
                           N_("User to use for auth."), NULL, NULL, NULL);
 static DRIZZLE_SYSVAR_STR(password, password, PLUGIN_VAR_READONLY,
@@ -329,6 +333,16 @@
 static DRIZZLE_SYSVAR_STR(db, db, PLUGIN_VAR_READONLY,
                           N_("Default database to use."), NULL, NULL, NULL);
 
+static void init_options(drizzled::module::option_context &context)
+{
+  context("enable",
+          po::value<bool>(&enabled)->default_value(false)->zero_tokens(),
+          N_("Enable the console."));
+  context("debug",
+          po::value<bool>(&debug_enabled)->default_value(false)->zero_tokens(),
+          N_("Turn on extra debugging."));
+}
+
 static drizzle_sys_var* vars[]= {
   DRIZZLE_SYSVAR(enable),
   DRIZZLE_SYSVAR(debug),
@@ -348,6 +362,6 @@
   PLUGIN_LICENSE_BSD,
   init,   /* Plugin Init */
   vars,   /* system variables */
-  NULL    /* config options */
+  init_options    /* config options */
 }
 DRIZZLE_DECLARE_PLUGIN_END;

=== modified file 'unittests/include.am'
--- unittests/include.am	2010-06-16 04:18:33 +0000
+++ unittests/include.am	2010-06-16 22:09:59 +0000
@@ -18,6 +18,7 @@
 			      unittests/main.cc \
 			      unittests/micro_timestamp_test.cc \
 			      unittests/nano_timestamp_test.cc \
+			      unittests/option_context.cc \
 			      unittests/plugin/authentication_test.cc \
 			      unittests/plugin/client_test.cc \
 			      unittests/plugin/error_message_test.cc \
@@ -32,4 +33,4 @@
 
 unittests_unittests_LDADD= \
   $(filter-out drizzled/main.$(OBJEXT), ${am_drizzled_drizzled_OBJECTS}) \
-  ${drizzled_drizzled_LDADD} ${LTLIBGTEST}
+  ${drizzled_drizzled_LDADD} ${LTLIBGTEST} ${BOOST_LIBS}

=== added file 'unittests/option_context.cc'
--- unittests/option_context.cc	1970-01-01 00:00:00 +0000
+++ unittests/option_context.cc	2010-06-16 22:09:59 +0000
@@ -0,0 +1,53 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Monty Taylor
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <gtest/gtest.h>
+#include <boost/program_options.hpp>
+
+#include "drizzled/module/option_context.h"
+
+namespace po=boost::program_options;
+
+using namespace drizzled;
+
+TEST(option_context, parsing)
+{
+  const std::string module_name("test");
+  po::options_description command_line_options("Test prefix injection");
+  module::option_context ctx(module_name, command_line_options.add_options());
+
+  ctx("option", po::value<std::string>(), "Test option name prefix injection");
+
+  po::variables_map vm;
+
+  const char *options[]= {
+    "test", "--test.option=foo"
+  };
+
+  po::store(po::command_line_parser(2, (char **)options).
+            options(command_line_options).run(), vm);
+  po::notify(vm);
+
+  EXPECT_EQ(0, vm.count("option"));
+  EXPECT_EQ(1, vm.count("test.option"));
+  EXPECT_EQ(0, vm["test.option"].as<std::string>().compare("foo"));
+}

